# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <ctype.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include "diaou_0.h"
//   


void      WORK_DIR(char *argv);
/*#####################################################################*/
void      WORK_DIR(char *argv)
/*
 *    Determine the working directory to open files.
 *    The diaou.conf file has to be into the same directory
 *    than the diaou.x executable.
 */
{// Start of WORK_DIR  =================================================
int l,i;
char c,*s_work_dir=NULL,*s_prov_fich=NULL;
char *ss = NULL;
FILE *fp;
int bb;
      ss = g_get_current_dir();
      printf("current_dir=%s@@@ \n",ss);
      g_free(ss); ss = NULL;
      l=strlen(argv);
         printf("argv[0]=%s@@@@ \n",argv);
      if(*(argv+l-1) != 'x' || *(argv+l-2) != '.'){
         printf("error not .x at end of argv[0]=%s@@@@ \n",argv);
	 exit(1);
      }//if(*(argv[0]+l-1) != 'x' || *(argv[0]+l-2) != '.'){
      l=l-2;
      while(l >= 0 && (c = *(argv+l)) != '/' && c != '\\')--l;
      printf("l=%d \n",l);
      s_work_dir = g_malloc((l+15)*sizeof(char));
      s_prov_fich = g_malloc((l+115)*sizeof(char));
      fp = fopen("./diaou.conf","r");
      if(fp != NULL){
         printf("level 1 fp OK \n");
	 g_free(s_work_dir);s_work_dir=NULL;
	 g_free(s_prov_fich);s_prov_fich=NULL;
//         strcpy(s_work_dir,"./");
	 fclose(fp);
	 return;
      }//if(fp != NULL){
      if(l < 0){
	 printf("file ./diaou.conf unreachable stop \n");
	 exit(1);
      }//if(l < 0){
      i=0;
      while(i <= l){
        c = *(argv+i);
	*( s_work_dir + i) = c;
         ++i;
      }//while(i <= l){
      *( s_work_dir + i) = '\0';
      if(*( s_work_dir + i-1) != '/'){
         printf("(*trf_work_dir).s_work_dir=%s \n",s_work_dir);
	 printf("I don't understand stop\n");
	 exit(1);
      }//if(*( (*trf_work_dir).s_work_dir + i-1) != '/'){
      printf("s_work_dir=%s \n",s_work_dir);
      strcpy(s_prov_fich,s_work_dir);
      strcat(s_prov_fich , "diaou.conf");
      printf("let us try s_prov_fich=%s \n",s_prov_fich);
      fp = fopen(s_prov_fich,"r");
      if(fp == NULL){
         printf("s_prov_fich=%s \n",s_prov_fich);
	 printf("file ./diaou.conf unreachable stop \n");
	 exit(1);
      }//if(fp != NULL){
      fclose(fp);
      printf("level 2 diaou.conf should be reachable, fp OK \n");
      bb = chdir(s_work_dir);
      fp = fopen("diaou.conf","r");
      if(fp == NULL){
         printf("after chdir s_work_dir=%s \n",s_work_dir);
	 printf("file ./diaou.conf unreachable stop \n");
	 exit(1);
      }//if(fp != NULL){
      printf("level 3 confirm diaou.conf IS reachable, fp OK \n");
	 g_free(s_work_dir);s_work_dir=NULL;
	 g_free(s_prov_fich);s_prov_fich=NULL;
      fclose(fp);
}// End of WORK_DIR  =================================================
/*#####################################################################*/
/********************************************************************/
/********************************************************************/
/********                                                  **********/
/********                 MAIN  PROGRAM                    **********/
/********                                                  **********/
/********************************************************************/
/********************************************************************/
/****                                                             ***/

int main(int argc, char **argv)
{
Trf_posit *t_posit ;
GtkWidget *pWindow;
//GtkWidget *pLabel1,*pLabel2;
GtkWidget *vBox1,*vBox2,*box_label;
GtkWidget *label0_file, *entry_book;
GtkWidget *separator1,*separator2, *quitbox, *button;
GtkWidget *button_sound;
GtkWidget *button_qr,*clrbox,*clr_butt,*redr_butt;
GtkWidget *QRbox ;
GtkWidget *next_less,*prev_less;
GtkWidget *scroll_page,*v_page, *Button1;
GtkWidget *scroll2_page,*v2_page,*text_view;
Trf_book *book;
Trf_err *t_err;
Prenestro *Caract_win;
Trf_string *G_kentel ;
GtkStyle *style;
PangoFontDescription *font_desc;
FILE *fp_log;
char *ss,ss_font_lesson[101];
char ss_font_vocab[101];
int i,ilesson;
int width0,height0,width_book;
Start_State *S_state;

#if LINUX
      WORK_DIR(argv[0]);
#endif
/*int modif;   
   modif =  win_file("./fich_lin_utf8","./wprov");
   printf("modifs win_file=%d \n",modif);*/
   Caract_win = g_malloc(sizeof(Prenestro));
   S_state = g_malloc(sizeof(Start_State));
   book = g_malloc(sizeof(Trf_book));
  (*book).lenmx_str_lessons = 49;
  (*book).lessons = g_malloc(((*book).lenmx_str_lessons +1)*sizeof(char));
  (*book).lenmx_path_of_lesson = 5;
  (*book).path_of_lesson = \
                 g_malloc(((*book).lenmx_path_of_lesson +5)*sizeof(char));
   G_kentel = g_malloc(sizeof(Trf_string));
   G_kentel -> st_lesson = NULL ;
   G_kentel -> st_idx1 = NULL ;
   G_kentel -> spath_idx1 = NULL ;
   G_kentel -> st_alias = NULL ;
   t_posit = g_malloc(sizeof(Trf_posit));
   t_err = g_malloc(sizeof(Trf_err));
   book->t_err = t_err ;
	 for(i = 0 ; i < MAX_LINE ; ++i){
	    book->wbutton[i] = NULL ;
	    book->lbox2[i] = NULL ;
	 }

    FURCH_SET(Caract_win,book,G_kentel,ss_font_lesson,ss_font_vocab);
   (*book).sound = 1;
      printf("After FURCH_SET \n");
    fflush(stdout);
   fp_log = fopen("diaou_log","w");
   CALC_INDEX( fp_log,G_kentel ,t_posit ) ;
    printf("in diaou.c after CALC_INDEX \n");
    fflush(stdout);
    if(G_kentel->st_lesson != NULL)\
    printf("G_kentel->st_lesson=%s@@@@\n",G_kentel->st_lesson);
    fflush(stdout);
    printf("G_kentel.nb_lesson=%d@@@@\n",(*G_kentel).nb_lesson);
    fflush(stdout);
    printf("diaou.c level -0.0 \n");
    fflush(stdout);
    if(G_kentel->st_idx1 != NULL)\
    printf("G_kentel->st_idx1=%s@@@@\n",G_kentel->st_idx1);
    fflush(stdout);
    printf("diaou.c level -0.1 \n");
    fflush(stdout);
    if(G_kentel->st_alias != NULL)\
    printf("G_kentel->st_alias=%s@@@@\n",G_kentel->st_alias);
    fflush(stdout);
    printf("diaou.c level -0.2 \n");
    fflush(stdout);

    printf("diaou.c level 0 \n");
    fflush(stdout);
   gtk_rc_parse ("diaou.rc");/** definition of fonts and colors 
				  used by GTK+   **/
   gtk_init(&argc,&argv);
    printf("diaou.c level 1 \n");
    fflush(stdout);
   START_PAGE_NUMBER(S_state,book);
      printf("After START_PAGE_NUMBER \n");
    fflush(stdout);
   pWindow=gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_position(GTK_WINDOW(pWindow),GTK_WIN_POS_CENTER);
/***   default value of the window size          ***/
      if((*S_state).root_width > 0 && (*S_state).root_height > 0){
           width0= (*S_state).root_width;
           height0= (*S_state).root_height;
           width_book = (*S_state).width_book;
      }else{
           width0= (*Caract_win).book_pix_size[0];
//           + (*Caract_win).npix_tot_dico[0] + 30; 
	   height0= (*Caract_win).book_pix_size[1];
           width_book= (*Caract_win).book_pix_size[2];
      }/*if((*S_state).root_width > 0 && (*S_state).root_width > 0){*/
      printf("Main_Window_default width=%d height=%d\n",width0,height0);
      printf("Book_Window_default width=%d \n",width_book);
      gtk_window_set_default_size(GTK_WINDOW(pWindow),width0,height0);
   gtk_window_set_resizable(GTK_WINDOW(pWindow),TRUE);
   g_signal_connect(G_OBJECT(pWindow),"destroy",G_CALLBACK(gtk_main_quit),NULL);

GtkWidget *hpaned = gtk_hpaned_new ();
/***   start position of the separation in pixels from left   ***/
      gtk_paned_set_position(GTK_PANED(hpaned),width_book);
   gtk_container_add(GTK_CONTAINER(pWindow),hpaned);
GtkWidget *frame1 = gtk_frame_new (NULL);
GtkWidget *frame2 = gtk_frame_new (NULL);
gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_IN);
gtk_frame_set_shadow_type (GTK_FRAME (frame2), GTK_SHADOW_IN);

//gtk_widget_set_size_request (hpaned, 200 + GTK_PANED (hpaned)->gutter_size, -1);

/*  size_request set a minimum for frame1  */
gtk_widget_set_size_request (frame1, 50, -1);
gtk_paned_pack1 (GTK_PANED (hpaned), frame1, TRUE, FALSE);
   gtk_widget_show(frame1);

gtk_paned_pack2 (GTK_PANED (hpaned), frame2, TRUE, FALSE);
/*  size_request set a minimum for frame2  otherwise frame1 takes 
 *  all the avalable place */
 gtk_widget_set_size_request (frame2, 50, -1);
/*   pLabel1 = gtk_label_new("Hello World");
   pLabel2 = gtk_label_new("Oui salut !");*/
//   gtk_widget_set_usize(pLabel,100,800);
      vBox2 = gtk_vbox_new (FALSE, 0);
      gtk_container_add(GTK_CONTAINER(frame2),vBox2);
/*    gtk_box_pack_start (GTK_BOX (vBox2), pLabel1, FALSE, FALSE, 0);
      gtk_box_pack_start (GTK_BOX (vBox2), pLabel2, FALSE, FALSE, 0);*/
/*
 */ 
      vBox1 = gtk_vbox_new (FALSE, 0);
      gtk_container_add(GTK_CONTAINER(frame1),vBox1);
      
/*
 *    the "box_label" box is an horizontal box which will pack 
 *    2 boxes. the first with the label: "file ;" and the second
 *    is an entry widget : entry_book
 *    name of first box : "label0_file
 *    name of second box :  "entry_book"
 */
      box_label = gtk_hbox_new (FALSE, 0);/**  a box to pack the label **/
//	    pango_font_description_from_string("Helvetica bald 25");
      gtk_box_pack_start (GTK_BOX (vBox1), box_label, FALSE, FALSE, 0);
          /* create a new label box whose name is "label0_file". */
          label0_file = gtk_label_new ("Cmd : ");
      style = gtk_style_copy(gtk_widget_get_style( GTK_WIDGET(label0_file)));
/***** Provisional   **********/
	    style -> font_desc = \
	    pango_font_description_from_string("helvetica 18");
//	    pango_font_description_from_string(ss_font);
/*	    style -> font_desc = \
	    pango_font_description_from_string(Caract_win -> font_dico);*/
	    gtk_widget_set_style(label0_file, style);
          gtk_box_pack_start (GTK_BOX (box_label), label0_file, FALSE, FALSE, 0);
          gtk_widget_show (label0_file);
/*
 *     Create the entry widget (the command line)
 *     to display the page filename in the book part
 */     
      entry_book = gtk_entry_new_with_max_length (50);
      /*  
       *  these four lines are working well...
       *  However it seems that we are also setting the font of the
       *  whole left part of the main window
       *  */
            style = gtk_style_copy(gtk_widget_get_style( GTK_WIDGET(entry_book)));
	    style -> font_desc = \
//??	    pango_font_description_from_string(ss_font);
//??	    pango_font_description_from_string("Helvetica bald 10");
	    pango_font_description_from_string(ss_font_vocab);
//	    pango_font_description_from_string(Caract_win -> font_dico);
	    gtk_widget_set_style(entry_book, style);
/*      (*Tentry).entry = entry ;  */
/* 
 * Activation of the widget (it is the return signal)
 */ 
      gtk_signal_connect(GTK_OBJECT(entry_book), "activate",
                         GTK_SIGNAL_FUNC(callback_entry_book), book);
/**/
      g_signal_connect((gpointer) entry_book, "button-press-event",
                         G_CALLBACK(clean_entry_book), book);
      gtk_box_pack_start (GTK_BOX (box_label), entry_book, TRUE, TRUE, 0);
      gtk_widget_show (entry_book);
/*
 */
      gtk_widget_show (box_label);
	  /*******************/
      scroll_page = gtk_scrolled_window_new (NULL,NULL);
          gtk_scrolled_window_set_policy \
		  (GTK_SCROLLED_WINDOW (scroll_page), \
		   GTK_POLICY_AUTOMATIC,GTK_POLICY_ALWAYS);
	  gtk_box_pack_start( GTK_BOX (vBox1),scroll_page,TRUE,TRUE,0);
/*    a vbox must be created to put in the scrolled page.
 *    the vbox of name v_page will contain the box lines which will
 *    contain the box words
 */
      v_page = gtk_vbox_new (FALSE, 0); /* viewport de scroll_page */
      gtk_scrolled_window_add_with_viewport \
	              (GTK_SCROLLED_WINDOW(scroll_page),v_page);
          gtk_widget_show(v_page);
      gtk_widget_show (scroll_page);
//
	  /*******************/
      scroll2_page = gtk_scrolled_window_new (NULL,NULL);
          gtk_scrolled_window_set_policy \
		  (GTK_SCROLLED_WINDOW (scroll2_page), \
		   GTK_POLICY_AUTOMATIC,GTK_POLICY_ALWAYS);
	  gtk_box_pack_start( GTK_BOX (vBox2),scroll2_page,TRUE,TRUE,0);
/*    a vbox must be created to put in the scrolled page.
 *    the vbox of name v_page will contain the box lines which will
 *    contain the box words
 */
      v2_page = gtk_vbox_new (FALSE, 0); /* viewport de scroll_page */
      gtk_scrolled_window_add_with_viewport \
	              (GTK_SCROLLED_WINDOW(scroll2_page),v2_page);
/*   pLabel1 = gtk_label_new("Hello World");
   pLabel2 = gtk_label_new("Oui salut !");
      gtk_box_pack_start (GTK_BOX (v2_page), pLabel1, FALSE, FALSE, 0);
      gtk_box_pack_start (GTK_BOX (v2_page), pLabel2, FALSE, FALSE, 0);*/
  /* Create a multiline text widget. */
  text_view = gtk_text_view_new ();
  gtk_text_view_set_editable (GTK_TEXT_VIEW (text_view), FALSE);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (text_view), GTK_WRAP_WORD_CHAR);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (text_view), 15);
  gtk_text_view_set_right_margin (GTK_TEXT_VIEW (text_view), 10);
  /* Change default font throughout the widget */
  font_desc = pango_font_description_from_string (ss_font_lesson);
  gtk_widget_modify_font (text_view, font_desc);
  pango_font_description_free (font_desc);
//
  gtk_box_pack_start (GTK_BOX (v2_page), text_view, 1, 1, 0);
  gtk_widget_show_all (v2_page);
//          gtk_widget_show(v2_page);
      gtk_widget_show (scroll2_page);
//

//      fp = fopen("k55.txt","r");
//      fp_log = fopen("diaoul_log.txt","r");
      book->fp_log = fp_log;
      book->pWindow = pWindow ;
      book->hpaned = hpaned ;
      book->frame1 = frame1 ;
      book->frame2 = frame2;
      book->vBox1 = vBox1 ;
      book->scroll_page = scroll_page ;
      book->scroll2_page = scroll2_page ;
      book->v_page = v_page ;
      book->v2_page = v2_page ;
      book->text_view = text_view ;
      (*book).nb_line = 0 ;
      (*book).state = 1;
      (*book).sens_qr = 1;
      (*book).toggle_sens_qr = 0;
      (*book).ilesson = 1;
      if((ilesson = (*S_state).sens_qr) != 0)(*book).sens_qr = ilesson;
      if((ilesson = (*S_state).num_lesson) != 0)(*book).ilesson = ilesson;
//      (*book).nbt_lesson = 2; computed into FURCH_SET
      printf("nbt_lesson=%d \n",(*book).nbt_lesson);
      book->t_posit = t_posit;
      book->G_kentel = G_kentel;
      book->entry_book = entry_book;
      book->style = style;
      (*book).start_lesson = 0;
      (*book).interro_sound = 1;
/*
 */
//      ilesson= (*book).ilesson;
//      CONFIRM0_LESSON(book);
//      INIT_LESSON(&ilesson,book);
//      DISPLAY_ARTICLE(book) ;
//
      QRbox = gtk_hbox_new (FALSE, 0);
      gtk_box_pack_start (GTK_BOX(vBox1), QRbox, FALSE, FALSE, 0);
//      buttonQ = gtk_button_new_with_label ("Q :");
//      gtk_box_pack_start (GTK_BOX(QRbox), buttonQ, FALSE, FALSE, 0);
//   gtk_widget_show (QRbox);
      separator1 = gtk_hseparator_new ();
      gtk_box_pack_start (GTK_BOX(vBox1), separator1, FALSE, TRUE, 5);
      gtk_widget_show (separator1);
      quitbox = gtk_hbox_new (FALSE, 0);
// 
      separator2 = gtk_hseparator_new ();
      gtk_box_pack_start (GTK_BOX(vBox2), separator2, FALSE, TRUE, 5);
      gtk_widget_show (separator2);
      clrbox = gtk_hbox_new (FALSE, 0);
/*
 *     The Quit button
 */
//      
      button = gtk_button_new_with_label ("Quit");
      gtk_widget_set_name( button , "buttonruz") ; 
//    g_signal_connect(G_OBJECT(button), "destroy", G_CALLBACK(gtk_main_quit), NULL);
      gtk_signal_connect(GTK_OBJECT (button),\
	    "clicked",  GTK_SIGNAL_FUNC (ON_QUIT), book );
      gtk_box_pack_start (GTK_BOX (quitbox), button, TRUE, FALSE, 0);

/*
 *     The next and previous lesson buttons
 */
      next_less = gtk_button_new_with_label ("Next");
      gtk_widget_set_name( next_less , "buttonnoir") ; 
      prev_less = gtk_button_new_with_label ("Prev");
      gtk_widget_set_name( prev_less , "buttonnoir") ; 
      gtk_signal_connect (GTK_OBJECT (next_less), "clicked",
                        GTK_SIGNAL_FUNC (cback_next_less),book);
      gtk_signal_connect (GTK_OBJECT (prev_less), "clicked",
                        GTK_SIGNAL_FUNC (cback_prev_less),book);
      gtk_box_pack_start (GTK_BOX (quitbox), prev_less, TRUE, FALSE,0);
      gtk_box_pack_start (GTK_BOX (quitbox), next_less, TRUE, FALSE,0);
      gtk_widget_show (next_less);
      gtk_widget_show (prev_less);
/*
 *     The Clr and ReDr (clear and redraw) buttons
 */
      clr_butt = gtk_button_new_with_label ("Clr");
      gtk_widget_set_name( clr_butt , "buttonnoir") ; 
      redr_butt = gtk_button_new_with_label ("ReDr");
      gtk_widget_set_name( redr_butt , "buttonnoir") ; 
      gtk_signal_connect (GTK_OBJECT (clr_butt), "clicked",
                        GTK_SIGNAL_FUNC (cback_clr_butt),book);
      gtk_signal_connect (GTK_OBJECT (redr_butt), "clicked",
                        GTK_SIGNAL_FUNC (cback_redr_butt),book);
      gtk_box_pack_start (GTK_BOX (clrbox), clr_butt, TRUE, FALSE,0);
      gtk_box_pack_start (GTK_BOX (clrbox), redr_butt, TRUE, FALSE,0);
      gtk_widget_show (clr_butt);
      gtk_widget_show (redr_butt);
/*
 * *************
 */
      if((*book).sound == 1){
         button_sound = gtk_button_new_with_label ("<)))");
      }else{//if((*book).sens_qr == 2){
         (*book).sound = 0 ;
         button_sound = gtk_button_new_with_label ("< XX");
      }//if((*book).sens_qr == 2){
      gtk_widget_set_name( button_sound , "buttonnoir") ; 
      gtk_box_pack_start (GTK_BOX (quitbox), button_sound, TRUE, FALSE, 0);
      g_signal_connect(GTK_OBJECT(button_sound),"button_press_event",
          GTK_SIGNAL_FUNC(callback_togsound),book);
      gtk_widget_show (button_sound);
      book->button_sound = button_sound ;
/*
 * *************
 */
      if((*book).sens_qr == 2){
         button_qr = gtk_button_new_with_label ("R->Q");
      }else{//if((*book).sens_qr == 2){
         (*book).sens_qr = 1 ;
         button_qr = gtk_button_new_with_label ("Q->R");
      }//if((*book).sens_qr == 2){
      gtk_widget_set_name( button_qr , "buttonnoir") ; 
      gtk_box_pack_start (GTK_BOX (quitbox), button_qr, TRUE, FALSE, 0);
      g_signal_connect(GTK_OBJECT(button_qr),"button_press_event",
          GTK_SIGNAL_FUNC(callback_togqr),book);
      gtk_widget_show (button_qr);
      book->button_qr = button_qr ;
//
//      CONFIRM0_LESSON(book);
/*
      button = gtk_button_new_with_label ("Quit");
      gtk_widget_set_name( button , "buttonruz") ; 
//    g_signal_connect(G_OBJECT(button), "destroy", G_CALLBACK(gtk_main_quit), NULL);
      gtk_signal_connect(GTK_OBJECT (button),\
	    "clicked",  GTK_SIGNAL_FUNC (ON_QUIT), book );
      gtk_box_pack_start (GTK_BOX (quitbox), button, TRUE, FALSE, 0);
*/
//     ss = g_locale_from_utf8(entry_text,-1,NULL,NULL,NULL);
//     ss = g_convert(entry_text,-1,"CP1252","UTF-8",NULL,NULL,NULL);
    ss = g_locale_to_utf8("  Question / Response  ", -1, NULL, NULL, NULL);
    Button1 = gtk_button_new_with_label(ss);
      gtk_widget_set_name( Button1 , "buttonyellow") ; 
    g_free(ss);
    gtk_box_pack_start(GTK_BOX(quitbox), Button1, FALSE, FALSE, 0);
    g_signal_connect(GTK_OBJECT(Button1),"button_press_event",
          GTK_SIGNAL_FUNC(callback_ok_nok),book);
   gtk_widget_show(Button1);
   book->Button1 = Button1;
      CONFIRM0_LESSON(book);

      gtk_box_pack_start (GTK_BOX(vBox1), quitbox, FALSE, FALSE, 0);
      gtk_box_pack_start (GTK_BOX(vBox2), clrbox, FALSE, FALSE, 0);
/*
 */

//   gtk_label_set_width_chars(GTK_LABEL(pLabel),800);
/*   gtk_widget_show(pLabel1);
   gtk_widget_show(pLabel2);*/
   gtk_widget_show (button);
   gtk_widget_show (quitbox);
   gtk_widget_show (clrbox);
   gtk_widget_show(vBox1);
   gtk_widget_show(vBox2);
   gtk_widget_show(frame2);
   gtk_widget_show(hpaned);
// gtk_widget_set_size_request (frame1, 50, -1);
   gtk_widget_show(pWindow);
      if( (*S_state).root_x >= 0 && (*S_state).root_y >= 0 ){
          gtk_window_move(GTK_WINDOW(pWindow)\
	  ,(*S_state).root_x, (*S_state).root_y);
      }/*if( (*S_state).root_x > 0 && (*S_state).root_y > 0 ){*/
   gtk_main();
   return EXIT_SUCCESS;
}
